#ifndef	BITMAP_H
#define	BITMAP_H

#include "MyTypes.h"

enum
{
	BITMAP_256,
	BITMAP_GREY,
	BITMAP_RGB,
	BITMAP_BGR,
};

typedef struct
{
	u16	width, height;
	u8	format;
	u8	*pPalette;
	u8	*pMem;
} TBitmap;

#define	BITMAP_ADDR8(_bm,_x,_y) ((_bm)->pMem + (_y) * (_bm)->width + (_x))
#define	BITMAP_ADDR16(_bm,_x,_y) ((_bm)->pMem + ((_y) * (_bm)->width + (_x)) * 2)
#define	BITMAP_ADDR24(_bm,_x,_y) ((_bm)->pMem + ((_y) * (_bm)->width + (_x)) * 3)

void	BITMAP_Init(TBitmap *p_pBitmap, u16 p_width, u16 p_height, u8 p_format);
u32		BITMAP_Alloc(TBitmap *p_pBitmap, u16 p_width, u16 p_height, u8 p_format);
void	BITMAP_Free(TBitmap *p_pBitmap);
void	BITMAP_Blt(TBitmap *p_pSrcbitmap, TBitmap *p_pDstbitmap, s32 posx, s32 posy);
COLORREF BITMAP_GetPix(TBitmap *p_bm, s32 p_x, s32 p_y);
void	BITMAP_SetPix(TBitmap *p_bm, s32 p_x, s32 p_y, COLORREF p_coul);
void	BITMAP_Rect(TBitmap *p_bm, u32 p_x, u32 p_y, u32 p_x2, u32 p_y2, COLORREF p_coul);
void	BITMAP_FillRect(TBitmap *p_bm, u32 p_x, u32 p_y, u32 p_x2, u32 p_y2, COLORREF p_coul);
void	BITMAP_Cls(TBitmap *p_bm, COLORREF p_coul);

#endif
