// retouche_gui.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include <stdio.h>
#include <commdlg.h>
#include <direct.h>
#include "retouche_gui.h"
#include "winstuf.h"
#include "error.h"
#include "tga.h"

#define	PROGNAME	"Retouche gui v1.1"

#define	BIT_HAUT	1
#define	BIT_BAS		2
#define	BIT_GAUCHE	4
#define	BIT_DROITE	8

#define COUL_FOND	RGB(160, 160, 160)

typedef struct
{
	u8	r, g, b;
} TColor;

struct SParams
{
	int		detect_width;
	int		detect_diff;
	int		blur_radius;
	int		blur_limit;
	int		vision_limit1;
	int		vision_limit2;
	int		vision_width1;
	int		vision_width2;
	int		vision_width3;
	u8		cote_recadrage;
	u8		cote_fond;
	u8		isRecadrage1;
	u8		isFlou;
	u8		isSauvegarde1;
	u8		isRotation;
	u8		isRecadrage2;
	u8		isSauvegarde2;
	u8		isShowFilters;
	u8		isSaveBlacknWhite;
	u8		isAutoColor;
	double	vision_angle;
	double	offset_angle;
	char	repertoire1[MAX_PATH];
	char	repertoire2[MAX_PATH];
	TColor	coul_remplissage;
};

enum
{
	ZOOM_100 = 0,
	ZOOM_50,
	ZOOM_PAGE
};

// Global Variables:
HMENU				g_Menu;
HINSTANCE			g_Instance;
HWND				g_CurDial;
struct SParams		p;
char				pConfPath[MAX_PATH];
char				pConfFile[MAX_PATH];
char				pImgPath[MAX_PATH];
char				pImgFile[MAX_PATH];
char				pCurPath[MAX_PATH];
char				pWorkDir[MAX_PATH];
u32					isimageloaded;
u32					part;
u32					up_to_date;
TBitmap				bm1, bm2;
u32					img_dstx1, img_dstx2, img_dstw, img_dsth;
u32					zoom;
u32					scrx, scry;

u32	g_pDials[] =
	{
		IDD_DIALOG2,	// retouche 1
		IDD_DIALOG3,	// flou
		IDD_DIALOG4,	// sauvegarde 1
		IDD_DIALOG5,	// filtre 1
		IDD_DIALOG6,	// filtre 2
		IDD_DIALOG7,	// filtre 3
		IDD_DIALOG8,	// filtre 4
		IDD_DIALOG9,	// filtre 5
		IDD_DIALOG10,	// rotation
		IDD_DIALOG11,	// recadrage 2
		IDD_DIALOG12,	// sauvegarde 2
	};

COLORREF	g_pCustColors[] = 
	{
		RGB(255, 255, 255),
		RGB(255, 255, 255),
		RGB(255, 255, 255),
		RGB(255, 255, 255),
		RGB(255, 255, 255),
		RGB(255, 255, 255),
		RGB(255, 255, 255),
		RGB(255, 255, 255),
		RGB(255, 255, 255),
		RGB(255, 255, 255),
		RGB(255, 255, 255),
		RGB(255, 255, 255),
		RGB(255, 255, 255),
		RGB(255, 255, 255),
		RGB(255, 255, 255),
		RGB(255, 255, 255)
	};

void InitDialog(HWND hDlg);
void SaveConfig(char *p_pFilename, char *p_pRep1, char *p_pRep2);
LRESULT CALLBACK DialogMessages(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);

LRESULT CALLBACK dummy(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	return (FALSE);
}

/////////////////////////////////////////////////////////////////////////////////////////////////////
///
/// Mise  jour de la taille des scrollbars
///
/////////////////////////////////////////////////////////////////////////////////////////////////////
void Prg_SetScroll(void)
{
	SCROLLINFO	scrollinfo;

	scrollinfo.cbSize = sizeof(SCROLLINFO);
	scrollinfo.fMask = SIF_PAGE | SIF_RANGE | SIF_POS | SIF_DISABLENOSCROLL;
	scrollinfo.nMin = 0;
    scrollinfo.nTrackPos = 0;

	if (isimageloaded == FALSE || zoom == ZOOM_PAGE)
	{
		scrollinfo.nPos = 0;
		scrollinfo.nMax = 0;
		scrollinfo.nPage = 1;
		SetScrollInfo(g_Win.window, SB_HORZ, &scrollinfo, true);
		SetScrollInfo(g_Win.window, SB_VERT, &scrollinfo, true);
	}
	else
	{
		u32	mx, my;
		u32	w, h;

		mx = (bm1.width > bm2.width ? bm1.width : bm2.width);
		my = (bm1.height > bm2.height ? bm1.height : bm2.height);
		w = (zoom == ZOOM_100 ? img_dstw : img_dstw*2);
		h = (zoom == ZOOM_100 ? img_dsth : img_dsth*2);

		if (mx > w)
		{
			scrollinfo.nMax = mx;
		}
		else
		{
			scrollinfo.nMax = 0;
		}

		if ((int)scrx > scrollinfo.nMax)
		{
			scrx = scrollinfo.nMax;
		}
		scrollinfo.nPos = scrx;

		scrollinfo.nPage = w;
		SetScrollInfo(g_Win.window, SB_HORZ, &scrollinfo, true);

		if (my > h)
		{
			scrollinfo.nMax = my;
		}
		else
		{
			scrollinfo.nMax = 0;
		}

		if ((int)scry > scrollinfo.nMax)
		{
			scry = scrollinfo.nMax;
		}
		scrollinfo.nPos = scry;

		scrollinfo.nPage = h;
		SetScrollInfo(g_Win.window, SB_VERT, &scrollinfo, true);
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////////////
///
/// Mise  jour des images
///
/// ordre des bits:
/// 0:init
/// 1:recadr1
/// 2:flou
/// 3:save1
/// 4:f1
/// 5:f2
/// 6:f3
/// 7:f4
/// 8:f5
/// 9:rot
/// 10:rec2
/// 11:sav2
///
/////////////////////////////////////////////////////////////////////////////////////////////////////
void Prg_Update(char *p_pDir, char *p_pFile, u32 p_bits)
{
	char pCmd[256];
	char pConf[256];
	HWND dial;

	dial = CreateDialog(g_Instance, MAKEINTRESOURCE(IDD_DIALOG_MAJ2), g_Win.window, (DLGPROC)dummy);
	strcpy(pConf, pCurPath);
	strcat(pConf, "retouche_gui_conf.txt");

	chdir(pCurPath);
	SaveConfig(pConf, "", pWorkDir);
	sprintf(pCmd, "retouche /c\"%s\" %s /d%d %s%s >c:\\poil.txt", pConf, (p.isSaveBlacknWhite ? "/b" : ""), p_bits, p_pDir, p_pFile);
	flushall();
	system(pCmd);
	DestroyWindow(dial);
	Prg_SetScroll();
}

/////////////////////////////////////////////////////////////////////////////////////////////////////
///
/// Conversion d'une image
///
/////////////////////////////////////////////////////////////////////////////////////////////////////
void Prg_Convert(char *p_pDir, char *p_pFile)
{
	char pCmd[256];
	char pConf[256];

	strcpy(pConf, pCurPath);
	strcat(pConf, "retouche_gui_conf.txt");

	chdir(pCurPath);
	SaveConfig(pConf, p.repertoire1, p.repertoire2);
	sprintf(pCmd, "retouche /c\"%s\" %s %s%s >c:\\poil.txt", pConf, (p.isSaveBlacknWhite ? "/b" : ""), p_pDir, p_pFile);
	flushall();
	system(pCmd);
}

/////////////////////////////////////////////////////////////////////////////////////////////////////
///
/// Charge les 2 images qu'on va afficher
///
/////////////////////////////////////////////////////////////////////////////////////////////////////
void Prg_LoadImage(void)
{
	char	pFiles[][2][20] =
		{
			{"save0.tga", "save1.tga"},		// recadrage 1
			{"save1.tga", "save2.tga"},		// flou
			{"save2.tga", "save3.tga"},		// save 1
			{"save3.tga", "save4.tga"},		// filtre 1
			{"save4.tga", "save5.tga"},		// filtre 2
			{"save5.tga", "save6.tga"},		// filtre 3
			{"save6.tga", "save7.tga"},		// filtre 4
			{"save7.tga", "save8.tga"},		// filtre 5
			{"save3.tga", "save9.tga"},		// rotation
			{"save9.tga", "save10.tga"},	// recadrage 2
			{"save10.tga", "save11.tga"},	// save 2
		};

	chdir(pWorkDir);

	if (bm1.pMem != NULL)
	{
		BITMAP_Free(&bm1);
	}

	if (TGA_Load(pFiles[part][0], &bm1) == FALSE)
	{
		isimageloaded = FALSE;
		Prg_SetScroll();
		return;
	}

	if (bm2.pMem != NULL)
	{
		BITMAP_Free(&bm2);
	}

	if (TGA_Load(pFiles[part][1], &bm2) == FALSE)
	{
		isimageloaded = FALSE;
		Prg_SetScroll();
	}
	Prg_SetScroll();
}

/////////////////////////////////////////////////////////////////////////////////////////////////////
///
/// Affiche les 2 images
///
/////////////////////////////////////////////////////////////////////////////////////////////////////
void Prg_DrawImage(void)
{
	u32	w, h, x, y, x2, y2;
	u32	div;
	COLORREF	c;

	if (isimageloaded == FALSE)
	{
		BITMAP_FillRect(&g_Win.bitmap, img_dstx1, 0, img_dstx1+img_dstw-1, img_dsth-1, COUL_FOND);
		BITMAP_FillRect(&g_Win.bitmap, img_dstx2, 0, img_dstx2+img_dstw-1, img_dsth-1, COUL_FOND);
	}
	else if (zoom == ZOOM_PAGE)
	{
		w = bm1.width;	// normalement, l'image 1 est toujours plus grande
		h = bm1.height;

		for (y=0; y<img_dsth; y++)
		{
			for (x=0; x<img_dstw; x++)
			{
				if (img_dsth*w/img_dstw < h)
				{
					x2  =x*h/img_dsth;
					y2 = y*h/img_dsth;
				}
				else
				{
					x2  =x*w/img_dstw;
					y2 = y*w/img_dstw;
				}

				if (x2 < bm1.width && y2 < bm1.height)
				{
					c = BITMAP_GetPix(&bm1, x2, y2);
				}
				else
				{
					c = COUL_FOND;
				}
				BITMAP_SetPix(&g_Win.bitmap, img_dstx1+x, y, c);

				if (x2 < bm2.width && y2 < bm2.height)
				{
					c = BITMAP_GetPix(&bm2, x2, y2);
				}
				else
				{
					c = COUL_FOND;
				}
				BITMAP_SetPix(&g_Win.bitmap, img_dstx2+x, y, c);
			}
		}
	}
	else
	{
		div = (zoom == ZOOM_50 ? 2 : 1);

		if (zoom == ZOOM_PAGE)
		{
			scrx = scry = 0;
		}

		w = (bm1.width/div > img_dstw ? img_dstw : bm1.width/div);
		h = (bm1.height/div > img_dsth ? img_dsth : bm1.height/div);

		for (y=0; y<h; y++)
		{
			for (x=0; x<w; x++)
			{
				c = BITMAP_GetPix(&bm1, scrx+x*div, scry+y*div);
				BITMAP_SetPix(&g_Win.bitmap, img_dstx1+x, y, c);
			}
		}

		if (w != img_dstw)
		{
			BITMAP_FillRect(&g_Win.bitmap, img_dstx1+w, 0, img_dstx1+img_dstw-1, h, COUL_FOND);
		}

		if (h != img_dsth)
		{
			BITMAP_FillRect(&g_Win.bitmap, img_dstx1, h, img_dstx1+img_dstw-1, img_dsth, COUL_FOND);
		}

		w = (bm2.width/div > img_dstw ? img_dstw : bm2.width/div);
		h = (bm2.height/div > img_dsth ? img_dsth : bm2.height/div);

		for (y=0; y<h; y++)
		{
			for (x=0; x<w; x++)
			{
				c = BITMAP_GetPix(&bm2, scrx+x*div, scry+y*div);
				BITMAP_SetPix(&g_Win.bitmap, img_dstx2+x, y, c);
			}
		}

		if (w != img_dstw)
		{
			BITMAP_FillRect(&g_Win.bitmap, img_dstx2+w, 0, img_dstx2+img_dstw-1, h, COUL_FOND);
		}

		if (h != img_dsth)
		{
			BITMAP_FillRect(&g_Win.bitmap, img_dstx2, h, img_dstx2+img_dstw-1, img_dsth, COUL_FOND);
		}
	}

	// copie la bitmap dans la fentre
	BitBlt(g_Win.dbuf.windowcontext, 0, 0, g_Win.bitmap.width, g_Win.bitmap.height, g_Win.dbuf.backbufcontext, 0, 0, SRCCOPY);
}

/////////////////////////////////////////////////////////////////////////////////////////////////////
///
/// initialisation des pramtres par dfaut
///
/////////////////////////////////////////////////////////////////////////////////////////////////////
void Prg_DefaultParams(void)
{
	p.detect_width = 20;
	p.detect_diff = 25;
	p.vision_limit1 = 64;
	p.vision_limit2 = 3;
	p.vision_width1 = 16;
	p.vision_width2 = 16;
	p.vision_width3 = 128;
	p.vision_angle = 3.0;
	p.blur_radius = 3;
	p.blur_limit = 50;
	strcpy(p.repertoire1, "c:\\t\\");
	strcpy(p.repertoire2, "c:\\trot\\");
	p.cote_fond = BIT_DROITE;
	p.cote_recadrage = BIT_DROITE|BIT_BAS;
	p.isRecadrage1 = TRUE;
	p.isFlou = TRUE;
	p.isSauvegarde1 = TRUE;
	p.isRotation = TRUE;
	p.isRecadrage2 = TRUE;
	p.isSauvegarde2 = TRUE;
	p.isShowFilters = FALSE;
	p.isSaveBlacknWhite = FALSE;
	p.offset_angle = 0.0;
	p.isAutoColor = TRUE;
	p.coul_remplissage.r = 0;
	p.coul_remplissage.g = 0;
	p.coul_remplissage.b = 0;
	pImgFile[0] = 0;
	pImgPath[0] = 0;
	pConfFile[0] = 0;
	pConfPath[0] = 0;
	isimageloaded = FALSE;
	part = 0;
	up_to_date = 0;
	zoom = ZOOM_PAGE;
	BITMAP_Init(&bm1, 0, 0, 0);
	BITMAP_Init(&bm2, 0, 0, 0);
}

/******************************************************************************
 *
 * Recopie une chaine de caractres en enlevant les espaces  la fin et les guillemets
 *
 ******************************************************************************/
void GetRep(char *p_pSrc, char *p_pDst)
{
	if (*p_pSrc == '\"')
	{
		p_pSrc++;
	}

	strcpy(p_pDst, p_pSrc);

	while (p_pDst[strlen(p_pDst)-1] == ' ')
	{
		p_pDst[strlen(p_pDst)-1] = 0;
	}

	if (p_pDst[strlen(p_pDst)-1] == '\"')
	{
		p_pDst[strlen(p_pDst)-1] = 0;
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////////////
///
/// charge un fichier de config
///
/////////////////////////////////////////////////////////////////////////////////////////////////////

enum
{
	TYPE_INT=0,
	TYPE_FLOAT,
	TYPE_STRING,
	TYPE_COTE,
	TYPE_BINAIRE,
	TYPE_COULEUR
};

typedef struct SPrm
{
	char	pCmd[40];
	int		type;
	void	*pVar;
} TPrm;

static TPrm g_pCmd[] =
{
	{"DETECT_WIDTH",		TYPE_INT,		&p.detect_width},
	{"DETECT_DIFF",			TYPE_INT,		&p.detect_diff},
	{"VISION_LIMIT1",		TYPE_INT,		&p.vision_limit1},
	{"VISION_LIMIT2",		TYPE_INT,		&p.vision_limit2},
	{"VISION_WIDTH1",		TYPE_INT,		&p.vision_width1},
	{"VISION_WIDTH2",		TYPE_INT,		&p.vision_width2},
	{"VISION_WIDTH3",		TYPE_INT,		&p.vision_width3},
	{"VISION_ANGLE",		TYPE_FLOAT,		&p.vision_angle},
	{"BLUR_RADIUS",			TYPE_INT,		&p.blur_radius},
	{"BLUR_LIMIT",			TYPE_INT,		&p.blur_limit},
	{"REPERTOIRE1",			TYPE_STRING,	p.repertoire1},
	{"REPERTOIRE2",			TYPE_STRING,	p.repertoire2},
	{"COTE_RECADRAGE",		TYPE_COTE,		&p.cote_recadrage},
	{"COTE_FOND",			TYPE_COTE,		&p.cote_fond},
	{"OFFSET_ANGLE",		TYPE_FLOAT,		&p.offset_angle},
	{"RECADRAGE1",			TYPE_BINAIRE,	&p.isRecadrage1},
	{"FLOU",				TYPE_BINAIRE,	&p.isFlou},
	{"SAUVEGARDE1",			TYPE_BINAIRE,	&p.isSauvegarde1},
	{"ROTATION",			TYPE_BINAIRE,	&p.isRotation},
	{"RECADRAGE2",			TYPE_BINAIRE,	&p.isRecadrage2},
	{"SAUVEGARDE2",			TYPE_BINAIRE,	&p.isSauvegarde2},
	{"COUL_REMPLISSAGE",	TYPE_COULEUR,	&p.coul_remplissage}
};

void LoadConfig(char *p_pFilename)
{
	FILE	*pFile;
	char	pTmp[256];
	char	pTmp2[256];
	char	*pPtr;
	u32		qt_params = sizeof(g_pCmd) / sizeof(g_pCmd[0]);
	u32		i, r, g, b;
	float	tmp;
	TColor	*pCoul;

	pFile = fopen(p_pFilename, "r");

	if (pFile == NULL)
	{
		return;
	}

	p.isAutoColor = TRUE;

	while (fgets(pTmp, 256, pFile) != NULL)
	{
		while(pTmp[strlen(pTmp)-1] == 0xA || pTmp[strlen(pTmp)-1] == 0xD)
		{
			pTmp[strlen(pTmp)-1] = 0;
		}

		pPtr = strchr(pTmp, '=');

		if (pPtr != NULL)
		{
			memcpy(pTmp2, pTmp, pPtr-pTmp);
			pTmp2[pPtr-pTmp] = 0;
			strupr(pTmp2);

			for (i=0; i<qt_params; i++)
			{
				if (strcmp(pTmp2, g_pCmd[i].pCmd) == 0)
				{
					switch (g_pCmd[i].type)
					{
						case TYPE_INT:
							sscanf(pPtr+1, "%d", g_pCmd[i].pVar);
							break;

						case TYPE_FLOAT:
							tmp = 0.0;
							sscanf(pPtr+1, "%f", &tmp);
							*((double *)g_pCmd[i].pVar) = tmp;
							break;

						case TYPE_STRING:
							GetRep(pPtr+1, (char *)g_pCmd[i].pVar);
							break;

						case TYPE_COTE:
							*((u8 *)g_pCmd[i].pVar) = 0;
							strcpy(pTmp, pPtr+1);
							strupr(pTmp);
							pPtr = pTmp;

							while (*pPtr != 0)
							{
								switch (*pPtr)
								{
									case 'H':
										*((u8 *)g_pCmd[i].pVar) |= BIT_HAUT;
										break;

									case 'B':
										*((u8 *)g_pCmd[i].pVar) |= BIT_BAS;
										break;

									case 'G':
										*((u8 *)g_pCmd[i].pVar) |= BIT_GAUCHE;
										break;

									case 'D':
										*((u8 *)g_pCmd[i].pVar) |= BIT_DROITE;
										break;
								}
								pPtr++;
							}
							break;

						case TYPE_BINAIRE:
							if (pPtr[1] == 'o' || pPtr[1] == 'O')
							{
								*((u8 *)g_pCmd[i].pVar) = TRUE;
							}
							else
							{
								*((u8 *)g_pCmd[i].pVar) = FALSE;
							}
							break;

						case TYPE_COULEUR:
							p.isAutoColor = FALSE;
							sscanf(pPtr+1, "%d,%d,%d", &r, &g, &b);
							pCoul = (TColor *)g_pCmd[i].pVar;
							pCoul->r = (u8)r;
							pCoul->g = (u8)g;
							pCoul->b = (u8)b;
							break;
					}
					break;
				}
			}

			if (i == qt_params)
			{
				printf("parametre inconnu \"%s\"\n", pTmp2);
			}
		}
	}
	fclose(pFile);
}


/////////////////////////////////////////////////////////////////////////////////////////////////////
///
/// sauve un fichier de config
///
/////////////////////////////////////////////////////////////////////////////////////////////////////
void SaveConfig(char *p_pFilename, char *p_pRep1, char *p_pRep2)
{
	FILE	*pFile;

	pFile = fopen(p_pFilename, "w");

	if (pFile == NULL)
	{
		return;
	}

	fprintf(pFile, "DETECT_WIDTH=%d\n",		p.detect_width);
	fprintf(pFile, "DETECT_DIFF=%d\n",		p.detect_diff);
	fprintf(pFile, "VISION_LIMIT1=%d\n",	p.vision_limit1);
	fprintf(pFile, "VISION_LIMIT2=%d\n",	p.vision_limit2);
	fprintf(pFile, "VISION_WIDTH1=%d\n",	p.vision_width1);
	fprintf(pFile, "VISION_WIDTH2=%d\n",	p.vision_width2);
	fprintf(pFile, "VISION_WIDTH3=%d\n",	p.vision_width3);
	fprintf(pFile, "VISION_ANGLE=%f\n",		(float)p.vision_angle);
	fprintf(pFile, "BLUR_RADIUS=%d\n",		p.blur_radius);
	fprintf(pFile, "BLUR_LIMIT=%d\n",		p.blur_limit);
	fprintf(pFile, "REPERTOIRE1=\"%s\"\n",	p_pRep1);
	fprintf(pFile, "REPERTOIRE2=\"%s\"\n",	p_pRep2);
	fprintf(pFile, "COTE_RECADRAGE=");

	if (p.cote_recadrage & BIT_HAUT)
	{
		fprintf(pFile, "H");
	}

	if (p.cote_recadrage & BIT_BAS)
	{
		fprintf(pFile, "B");
	}

	if (p.cote_recadrage & BIT_GAUCHE)
	{
		fprintf(pFile, "G");
	}

	if (p.cote_recadrage & BIT_DROITE)
	{
		fprintf(pFile, "D");
	}
	fprintf(pFile, "\n");

	fprintf(pFile, "COTE_FOND=");
	
	if (p.cote_fond & BIT_HAUT)
	{
		fprintf(pFile, "H");
	}

	if (p.cote_fond & BIT_BAS)
	{
		fprintf(pFile, "B");
	}

	if (p.cote_fond & BIT_GAUCHE)
	{
		fprintf(pFile, "G");
	}

	if (p.cote_fond & BIT_DROITE)
	{
		fprintf(pFile, "D");
	}
	fprintf(pFile, "\n");

	fprintf(pFile, "OFFSET_ANGLE=%f\n",		(float)p.offset_angle);
	fprintf(pFile, "RECADRAGE1=%c\n",		(p.isRecadrage1 == TRUE ? 'O' : 'N'));
	fprintf(pFile, "FLOU=%c\n",				(p.isFlou == TRUE ? 'O' : 'N'));
	fprintf(pFile, "SAUVEGARDE1=%c\n",		(p.isSauvegarde1 == TRUE ? 'O' : 'N'));
	fprintf(pFile, "ROTATION=%c\n",			(p.isRotation == TRUE ? 'O' : 'N'));
	fprintf(pFile, "RECADRAGE2=%c\n",		(p.isRecadrage2 == TRUE ? 'O' : 'N'));
	fprintf(pFile, "SAUVEGARDE2=%c\n",		(p.isSauvegarde2 == TRUE ? 'O' : 'N'));

	if (p.isAutoColor == FALSE)
	{
		fprintf(pFile, "COUL_REMPLISSAGE=%d,%d,%d\n", p.coul_remplissage.r, p.coul_remplissage.g, p.coul_remplissage.b);
	}
	fclose(pFile);
}

/////////////////////////////////////////////////////////////////////////////////////////////////////
///
/// Appel d'un dialogue de couleur
///
/////////////////////////////////////////////////////////////////////////////////////////////////////
COLORREF Color(COLORREF p_initcol)
{
	CHOOSECOLOR	s;
	s.lStructSize = sizeof(CHOOSECOLOR);
	s.hwndOwner = g_Win.window;
	s.hInstance = NULL;
	s.lpCustColors = g_pCustColors;
	s.rgbResult = p_initcol;
	s.Flags = CC_FULLOPEN|CC_RGBINIT|CC_ANYCOLOR;
	s.lCustData = NULL;
	s.lpfnHook = NULL;
	s.lpTemplateName = NULL;

	if (ChooseColor(&s) != 0)
	{
		return (s.rgbResult);
	}
	else
	{
		return (p_initcol);
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////////////
///
/// Affiche les infos du programme
///
/////////////////////////////////////////////////////////////////////////////////////////////////////
void Prg_About(void)
{
	char	pHelp[1024];

	strcpy(pHelp, PROGNAME);
	strcat(pHelp, "\npar F. Goset\n");
	MessageBox(NULL, pHelp, "About", MB_ICONINFORMATION|MB_OK);
}

/////////////////////////////////////////////////////////////////////////////////////////////////////
///
/// Spare le path d'un nom de fichier
///
/////////////////////////////////////////////////////////////////////////////////////////////////////
void SplitPath(char *p_pFile, char *p_pPath)
{
	char	*pChr;
	char	*pChr2;

	strcpy(p_pPath, p_pFile);
	pChr = strrchr(p_pPath, '\\');
	pChr2 = strrchr(p_pPath, ':');

	if (pChr2 > pChr)
	{
		pChr = pChr2;
	}

	pChr2 = strrchr(p_pPath, '/');

	if (pChr2 > pChr)
	{
		pChr = pChr2;
	}

	if (pChr == NULL)
	{
		*p_pPath = 0;
	}
	else
	{
		strcpy(p_pFile, pChr+1);
		*(pChr+1) = 0;
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////////////
///
/// gestion des messages des menus
///
/////////////////////////////////////////////////////////////////////////////////////////////////////
void Wnd_ManageMenu(HWND p_window, u32 p_menu)
{
	char	pConfFilter[60] = "Text Files (.txt)\0*.txt\0All Files (*.*)\0*.*\0";
	char	pImgFilter[60] = "Targa Files (.tga)\0*.tga\0Tiff Files (*.tif)\0*.tif\0";
	char	pFile[MAX_PATH];
	TBitmap	bm;
	char	pMul[MAX_PATH*100];
	char	*pPtr;

	switch (p_menu)
	{
		case ID_AIDE_APROPOS:
			Prg_About();
			break;

		case ID_FICHIER_CHARGERCONFIG:
			WIN_FileRequest(g_Win.window, pConfFile, FR_LOAD, "Charger un fichier de config", pConfFilter, pConfPath, pConfFile);
			SplitPath(pConfFile, pConfPath);

			if (pConfFile[0] != 0)
			{
				strcpy(pFile, pConfPath);
				strcat(pFile, pConfFile);
				LoadConfig(pFile);
				InitDialog(g_CurDial);

				if (isimageloaded == TRUE)
				{
					Prg_Update(pImgPath, pImgFile, 0xFFF);
					up_to_date = 12;
					Prg_LoadImage();
					Prg_DrawImage();
				}
			}
			break;

		case ID_FICHIER_SAUVERCONFIG:
			WIN_FileRequest(g_Win.window, pConfFile, FR_SAVE, "Sauver un fichier de config", pConfFilter, pConfPath, pConfFile);
			SplitPath(pConfFile, pConfPath);

			if (pConfFile[0] != 0)
			{
				strcpy(pFile, pConfPath);
				strcat(pFile, pConfFile);
				SaveConfig(pFile, p.repertoire1, p.repertoire2);
			}
			break;

		case ID_FICHIER_CHARGERIMAGE:
			WIN_FileRequest(g_Win.window, pImgFile, FR_LOAD, "Charger une image", pImgFilter, pImgPath, pImgFile);
			SplitPath(pImgFile, pImgPath);

			if (pImgFile[0] != 0)
			{
				chdir(pImgPath);

				if (TGA_Load(pImgFile, &bm) == TRUE)
				{
					BITMAP_Free(&bm);
					isimageloaded = TRUE;
					Prg_Update(pImgPath, pImgFile, 0xFFF);
					up_to_date = 12;
					Prg_LoadImage();
					Prg_DrawImage();
				}
				else
				{
					isimageloaded = FALSE;
					Prg_SetScroll();
				}
			}
			else
			{
				isimageloaded = FALSE;
				Prg_SetScroll();
			}
			break;

		case ID_FICHIER_QUITTER:
			WIN_StdClose(g_Win.window);
			break;

		case ID_ZOOM_100:
			CheckMenuItem(g_Menu, ID_ZOOM_100, MF_BYCOMMAND|MF_CHECKED);
			CheckMenuItem(g_Menu, ID_ZOOM_50, MF_BYCOMMAND|MF_UNCHECKED);
			CheckMenuItem(g_Menu, ID_ZOOM_PLEINEPAGE, MF_BYCOMMAND|MF_UNCHECKED);
			zoom = ZOOM_100;
			Prg_SetScroll();
			Prg_DrawImage();
			break;

		case ID_ZOOM_50:
			CheckMenuItem(g_Menu, ID_ZOOM_100, MF_BYCOMMAND|MF_UNCHECKED);
			CheckMenuItem(g_Menu, ID_ZOOM_50, MF_BYCOMMAND|MF_CHECKED);
			CheckMenuItem(g_Menu, ID_ZOOM_PLEINEPAGE, MF_BYCOMMAND|MF_UNCHECKED);
			zoom = ZOOM_50;
			Prg_SetScroll();
			Prg_DrawImage();
			break;

		case ID_ZOOM_PLEINEPAGE:
			CheckMenuItem(g_Menu, ID_ZOOM_100, MF_BYCOMMAND|MF_UNCHECKED);
			CheckMenuItem(g_Menu, ID_ZOOM_50, MF_BYCOMMAND|MF_UNCHECKED);
			CheckMenuItem(g_Menu, ID_ZOOM_PLEINEPAGE, MF_BYCOMMAND|MF_CHECKED);
			zoom = ZOOM_PAGE;
			Prg_SetScroll();
			Prg_DrawImage();
			break;

		case ID_FICHIER_CONVERTIR:
			WIN_FileRequest(g_Win.window, pMul, FR_MULTI, "Choisir les images", pImgFilter, pImgPath, pImgFile);
			if (pMul[0] != 0)
			{
				if (pMul[strlen(pMul)+1] == 0)
				{
					// 1 seul fichier
					strcpy(pImgFile, pMul);
					SplitPath(pImgFile, pImgPath);
					Prg_Convert(pImgPath, pImgFile);
				}
				else
				{
					// plusieurs fichiers
					pPtr = &pMul[strlen(pMul)+1];

					while (*pPtr != 0)
					{
						Prg_Convert(pMul, pPtr);
						pPtr = &pPtr[strlen(pPtr)+1];
					}
				}
			}
			break;

		default:
			break;
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////////////
///
/// Initialise une Check Box
///
/////////////////////////////////////////////////////////////////////////////////////////////////////
void SetCheck(HWND hDlg, u32 p_control, u32 p_isChecked)
{
	HWND	hwnd = GetDlgItem(hDlg, p_control);

	if (hwnd != NULL)
	{
		CheckDlgButton(hDlg, p_control, (p_isChecked == FALSE ? BST_UNCHECKED : BST_CHECKED));
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////////////
///
/// Initialise un Edit Control avec une chaine de caratres
///
/////////////////////////////////////////////////////////////////////////////////////////////////////
void SetEditString(HWND hDlg, u32 p_control, char *p_pString)
{
	HWND	hwnd = GetDlgItem(hDlg, p_control);

	if (hwnd != NULL)
	{
		SendMessage(hwnd, WM_SETTEXT, FALSE, (LPARAM)p_pString);
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////////////
///
/// Initialise un Edit Control avec un chiffre
///
/////////////////////////////////////////////////////////////////////////////////////////////////////
void SetEditNum(HWND hDlg, u32 p_control, u32 p_value)
{
	char	pBuf[256];

	sprintf(pBuf, "%d", p_value);
	SetEditString(hDlg, p_control, pBuf);
}

/////////////////////////////////////////////////////////////////////////////////////////////////////
///
/// Initialise un Edit Control avec un flotant
///
/////////////////////////////////////////////////////////////////////////////////////////////////////
void SetEditFloat(HWND hDlg, u32 p_control, double p_value)
{
	char	pBuf[256];

	sprintf(pBuf, "%f", p_value);
	SetEditString(hDlg, p_control, pBuf);
}

/////////////////////////////////////////////////////////////////////////////////////////////////////
///
/// Rcupre une chaine d'un Edit Control
///
/////////////////////////////////////////////////////////////////////////////////////////////////////
void GetEditString(HWND hDlg, u32 p_control, char *p_pString)
{
	HWND	hwnd = GetDlgItem(hDlg, p_control);

	if (hwnd != NULL)
	{
		SendMessage(hwnd, EM_GETLINE, 0, (LPARAM)p_pString);
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////////////
///
/// Rcupre un nombre d'un Edit Control
///
/////////////////////////////////////////////////////////////////////////////////////////////////////
s32 GetEditNum(HWND hDlg, u32 p_control)
{
	s32		v;
	char	b[256];
	HWND	hwnd = GetDlgItem(hDlg, p_control);

	if (hwnd != NULL)
	{
		GetEditString(hDlg, p_control, b);
		sscanf(b, "%d", &v);
		return(v);
	}
	return (0);
}

/////////////////////////////////////////////////////////////////////////////////////////////////////
///
/// Rcupre un float d'un Edit Control
///
/////////////////////////////////////////////////////////////////////////////////////////////////////
double GetEditFloat(HWND hDlg, u32 p_control)
{
	float	v;
	char	b[256];
	HWND	hwnd = GetDlgItem(hDlg, p_control);

	if (hwnd != NULL)
	{
		GetEditString(hDlg, p_control, b);
		sscanf(b, "%f", &v);
		return((double)v);
	}
	return (0);
}

/////////////////////////////////////////////////////////////////////////////////////////////////////
///
/// Active ou dsactive un controle
///
/////////////////////////////////////////////////////////////////////////////////////////////////////
void EnableControl(HWND hDlg, u32 p_control, u32 p_isEnabled)
{
	HWND	hwnd = GetDlgItem(hDlg, p_control);

	if (hwnd != NULL)
	{
		EnableWindow(hwnd, p_isEnabled);
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////////////
///
/// Initialise les boutons des dialogue  partir des variables
///
/////////////////////////////////////////////////////////////////////////////////////////////////////
void InitDialog(HWND hDlg)
{
	HWND	hwnd;

	hwnd = GetDlgItem(hDlg, IDC_COMBO1);

	if (hwnd != NULL)
	{
		SendMessage(hwnd, CB_ADDSTRING, 0, (LPARAM) (LPCSTR)"Recadrage 1");
		SendMessage(hwnd, CB_ADDSTRING, 0, (LPARAM) (LPCSTR)"Flou");
		SendMessage(hwnd, CB_ADDSTRING, 0, (LPARAM) (LPCSTR)"Sauvegarde 1");
		SendMessage(hwnd, CB_ADDSTRING, 0, (LPARAM) (LPCSTR)"Filtre 1");
		SendMessage(hwnd, CB_ADDSTRING, 0, (LPARAM) (LPCSTR)"Filtre 2");
		SendMessage(hwnd, CB_ADDSTRING, 0, (LPARAM) (LPCSTR)"Filtre 3");
		SendMessage(hwnd, CB_ADDSTRING, 0, (LPARAM) (LPCSTR)"Filtre 4");
		SendMessage(hwnd, CB_ADDSTRING, 0, (LPARAM) (LPCSTR)"Filtre 5");
		SendMessage(hwnd, CB_ADDSTRING, 0, (LPARAM) (LPCSTR)"Rotation");
		SendMessage(hwnd, CB_ADDSTRING, 0, (LPARAM) (LPCSTR)"Recadrage 2");
		SendMessage(hwnd, CB_ADDSTRING, 0, (LPARAM) (LPCSTR)"Sauvegarde 2");
		SendDlgItemMessage(hDlg, IDC_COMBO1, CB_SETCURSEL, 0, 0); 
	}

	hwnd = GetDlgItem(hDlg, IDC_COTE_FOND);

	if (hwnd != NULL)
	{
		SendMessage(hwnd, CB_ADDSTRING, 0, (LPARAM) (LPCSTR)"Haut");
		SendMessage(hwnd, CB_ADDSTRING, 0, (LPARAM) (LPCSTR)"Bas");
		SendMessage(hwnd, CB_ADDSTRING, 0, (LPARAM) (LPCSTR)"Gauche");
		SendMessage(hwnd, CB_ADDSTRING, 0, (LPARAM) (LPCSTR)"Droite");

		switch (p.cote_fond)
		{
			case BIT_HAUT:
				SendDlgItemMessage(hDlg, IDC_COTE_FOND, CB_SETCURSEL, 0, 0); 
				break;

			case BIT_BAS:
				SendDlgItemMessage(hDlg, IDC_COTE_FOND, CB_SETCURSEL, 1, 0); 
				break;

			case BIT_GAUCHE:
				SendDlgItemMessage(hDlg, IDC_COTE_FOND, CB_SETCURSEL, 2, 0); 
				break;

			case BIT_DROITE:
				SendDlgItemMessage(hDlg, IDC_COTE_FOND, CB_SETCURSEL, 3, 0); 
				break;
		}
	}

	SetCheck(hDlg, IDC_ACTIV_RECADRAGE1,	p.isRecadrage1);
	SetCheck(hDlg, IDC_ACTIV_SAUVEGARDE1,	p.isSauvegarde1);
	SetCheck(hDlg, IDC_ACTIV_BLUR,			p.isFlou);
	SetCheck(hDlg, IDC_ACTIV_ROTATION,		p.isRotation);
	SetCheck(hDlg, IDC_ACTIV_RECADRAGE2,	p.isRecadrage2);
	SetCheck(hDlg, IDC_ACTIV_SAUVEGARDE2,	p.isSauvegarde2);

	SetCheck(hDlg, IDC_COTE_RECADRAGE_H, p.cote_recadrage & BIT_HAUT);
	SetCheck(hDlg, IDC_COTE_RECADRAGE_B, p.cote_recadrage & BIT_BAS);
	SetCheck(hDlg, IDC_COTE_RECADRAGE_G, p.cote_recadrage & BIT_GAUCHE);
	SetCheck(hDlg, IDC_COTE_RECADRAGE_D, p.cote_recadrage & BIT_DROITE);

	SetEditNum(hDlg, IDC_DETECT_DIFF,	p.detect_diff);
	SetEditNum(hDlg, IDC_DETECT_WIDTH,	p.detect_width);
	SetEditNum(hDlg, IDC_BLUR_RADIUS,	p.blur_radius);
	SetEditNum(hDlg, IDC_BLUR_LIMIT,	p.blur_limit);

	SetCheck(hDlg, IDC_SAUV_NB, p.isSaveBlacknWhite);
	SetEditString(hDlg, IDC_REPERTOIRE1, p.repertoire1);

	SetEditNum(hDlg, IDC_VISION_LIMIT1,	p.vision_limit1);
	SetEditNum(hDlg, IDC_VISION_LIMIT2,	p.vision_limit2);
	SetEditNum(hDlg, IDC_VISION_WIDTH1,	p.vision_width1);
	SetEditNum(hDlg, IDC_VISION_WIDTH2,	p.vision_width2);
	SetEditNum(hDlg, IDC_VISION_WIDTH3,	p.vision_width3);
	SetEditFloat(hDlg, IDC_VISION_ANGLE, p.vision_angle);

	SetEditFloat(hDlg, IDC_OFFSET_ANGLE, p.offset_angle);
	SetCheck(hDlg, IDC_COULEUR_AUTO, p.isAutoColor);

	if (p.isAutoColor == TRUE)
	{
		EnableControl(hDlg, IDC_FOND_R, FALSE);
		EnableControl(hDlg, IDC_FOND_V, FALSE);
		EnableControl(hDlg, IDC_FOND_B, FALSE);
		EnableControl(hDlg, IDC_CHOOSE_COLOR, FALSE);
	}
	SetEditNum(hDlg, IDC_FOND_R, p.coul_remplissage.r);
	SetEditNum(hDlg, IDC_FOND_V, p.coul_remplissage.g);
	SetEditNum(hDlg, IDC_FOND_B, p.coul_remplissage.b);

	SetEditString(hDlg, IDC_REPERTOIRE2, p.repertoire2);
}

/////////////////////////////////////////////////////////////////////////////////////////////////////
///
/// Rcupre un rpertoire
///
/////////////////////////////////////////////////////////////////////////////////////////////////////
void GetDir(char *p_pDir)
{
	char	pD[MAX_PATH];

	WIN_FileRequest(g_Win.window, pD, FR_DIR, "Choisissez un rpertoire de sauvegarde", "", "", "");

	if (pD[0] == 0)
	{
		return;
	}
	strcpy(p_pDir, pD);
}

/////////////////////////////////////////////////////////////////////////////////////////////////////
///
/// Gre les messages des scrollbars
///
/////////////////////////////////////////////////////////////////////////////////////////////////////
LRESULT Wnd_ManageScroll(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	static SCROLLINFO	scrollinfo =
		{
			sizeof(SCROLLINFO),
			SIF_PAGE | SIF_RANGE,
			0,	/// min
			0,	/// max
			1,	/// page
			0,	/// pos
			0	/// trackpos
		};
	u32	w, h;

	if (zoom == ZOOM_PAGE)
	{
		return(0);
	}

	w = (zoom == ZOOM_100 ? img_dstw : img_dstw*2);
	h = (zoom == ZOOM_100 ? img_dsth : img_dsth*2);

	// Check which message was passed in
	switch (message)
	{
		case WM_HSCROLL:
			switch(LOWORD(wParam))
			{
				case SB_LINELEFT: // The user has requested to "scroll left by one unit"
					if (scrx > 0)
					{
						scrx--;
					}
					break;

				case SB_LINERIGHT: // User has requested to "scroll right by one unit"
					if (scrx < w-1)
					{
						scrx++;
					}
					break;

				case SB_PAGELEFT:
					if (scrx >= 100)
					{
						scrx -= 100;
					}
					break;

				case SB_PAGERIGHT:
					if (scrx < w-100)
					{
						scrx += 100;
					}
					break;

				case SB_THUMBPOSITION: // The user has dragged the scroll box (by clicking it, dragging it, and then 
				case SB_THUMBTRACK: // The user has dragged the scroll box (by clicking it, dragging it, and then 
					scrx = HIWORD(wParam); // The HIWORD of the wparam is the NEW position of the thumb
					break;

				default:
					break;
			}

			Prg_DrawImage();
			Prg_SetScroll();
			break;

		case WM_VSCROLL:
			switch(LOWORD(wParam))
			{
				case SB_LINELEFT: // The user has requested to "scroll left by one unit"
					if (scry > 0)
					{
						scry--;
					}
					break;

				case SB_LINERIGHT: // User has requested to "scroll right by one unit"
					if (scry < h-1)
					{
						scry++;
					}
					break;

				case SB_PAGELEFT:
					if (scry >= 100)
					{
						scry -= 10;
					}
					break;

				case SB_PAGERIGHT:
					if (scry < h-100)
					{
						scry += 100;
					}
					break;

				case SB_THUMBPOSITION: // The user has dragged the scroll box (by clicking it, dragging it, and then 
				case SB_THUMBTRACK: // The user has dragged the scroll box (by clicking it, dragging it, and then 
					scry = HIWORD(wParam); // The HIWORD of the wparam is the NEW position of the thumb
					break;

				default:
					break;
			}

			Prg_DrawImage();
			Prg_SetScroll();
			break;
	}
	return (0);
}

/////////////////////////////////////////////////////////////////////////////////////////////////////
///
/// Gre les messages des diffrents dialogues
///
/////////////////////////////////////////////////////////////////////////////////////////////////////
LRESULT CALLBACK DialogMessages(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	u32	i, u, sutd;
	COLORREF	c;

	switch (message)
	{
		case WM_INITDIALOG:
			sutd = up_to_date;
			InitDialog(hDlg);
			up_to_date = sutd;
			return TRUE;

		case WM_COMMAND: 
			switch (HIWORD(wParam))
			{
				// modification d'une combo-box
				case CBN_SELENDOK:
					switch (LOWORD(wParam)) 
					{ 
						case IDC_COMBO1:
							part = (u32)SendMessage((HWND)lParam, CB_GETCURSEL, 0, 0);
							DestroyWindow(g_CurDial);
							g_CurDial = CreateDialog(g_Instance, MAKEINTRESOURCE(g_pDials[part]), g_Win.window, (DLGPROC)DialogMessages);

							if (up_to_date <= part)
							{
								u = 0;

								for (i=up_to_date; i<=part; i++)
								{
									u |= 1 << (i+1);
								}

								Prg_Update(pImgPath, pImgFile, u);
								up_to_date = part + 1;
							}

							Prg_LoadImage();
							Prg_DrawImage();
							return TRUE;

						case IDC_COTE_FOND:
							i = (u32)SendMessage((HWND)lParam, CB_GETCURSEL, 0, 0);
							up_to_date = part;

							switch(i)
							{
								case 0:
									p.cote_fond = BIT_HAUT;
									break;
								case 1:
									p.cote_fond = BIT_BAS;
									break;
								case 2:
									p.cote_fond = BIT_GAUCHE;
									break;
								case 3:
									p.cote_fond = BIT_DROITE;
									break;
							}
							return TRUE;
					}
					break;

				// click sur un bouton
				case BN_CLICKED:
					switch (LOWORD(wParam)) 
					{ 
						case IDC_CHOOSE_COLOR:
							up_to_date = part;
							c = Color(RGB(p.coul_remplissage.r, p.coul_remplissage.g, p.coul_remplissage.b));
							p.coul_remplissage.r = GetRValue(c);
							p.coul_remplissage.g = GetGValue(c);
							p.coul_remplissage.b = GetBValue(c);
							SetEditNum(hDlg, IDC_FOND_R, p.coul_remplissage.r);
							SetEditNum(hDlg, IDC_FOND_V, p.coul_remplissage.g);
							SetEditNum(hDlg, IDC_FOND_B, p.coul_remplissage.b);
							return TRUE;

						case IDC_ACTIV_RECADRAGE1:
							up_to_date = part;
							p.isRecadrage1 = (IsDlgButtonChecked(hDlg, IDC_ACTIV_RECADRAGE1) == BST_CHECKED ? TRUE : FALSE);
							return TRUE;

						case IDC_ACTIV_SAUVEGARDE1:
							up_to_date = part;
							p.isSauvegarde1 = (IsDlgButtonChecked(hDlg, IDC_ACTIV_SAUVEGARDE1) == BST_CHECKED ? TRUE : FALSE);
							return TRUE;

						case IDC_ACTIV_BLUR:
							up_to_date = part;
							p.isFlou = (IsDlgButtonChecked(hDlg, IDC_ACTIV_BLUR) == BST_CHECKED ? TRUE : FALSE);
							return TRUE;

						case IDC_ACTIV_ROTATION:
							up_to_date = part;
							p.isRotation = (IsDlgButtonChecked(hDlg, IDC_ACTIV_ROTATION) == BST_CHECKED ? TRUE : FALSE);
							return TRUE;

						case IDC_ACTIV_RECADRAGE2:
							up_to_date = part;
							p.isRecadrage2 = (IsDlgButtonChecked(hDlg, IDC_ACTIV_RECADRAGE2) == BST_CHECKED ? TRUE : FALSE);
							return TRUE;

						case IDC_ACTIV_SAUVEGARDE2:
							up_to_date = part;
							p.isSauvegarde2 = (IsDlgButtonChecked(hDlg, IDC_ACTIV_SAUVEGARDE2) == BST_CHECKED ? TRUE : FALSE);
							return TRUE;

						case IDC_SAUV_NB:
							up_to_date = part;
							p.isSaveBlacknWhite = (IsDlgButtonChecked(hDlg, IDC_SAUV_NB) == BST_CHECKED ? TRUE : FALSE);
							return TRUE;

						case IDC_COTE_RECADRAGE_H:
							up_to_date = part;
							if (IsDlgButtonChecked(hDlg, IDC_COTE_RECADRAGE_H) == BST_CHECKED)
							{
								p.cote_recadrage |= BIT_HAUT;
							}
							else
							{
								p.cote_recadrage &= ~BIT_HAUT;
							}
							return TRUE;

						case IDC_COTE_RECADRAGE_B:
							up_to_date = part;
							if (IsDlgButtonChecked(hDlg, IDC_COTE_RECADRAGE_B) == BST_CHECKED)
							{
								p.cote_recadrage |= BIT_BAS;
							}
							else
							{
								p.cote_recadrage &= ~BIT_BAS;
							}
							return TRUE;

						case IDC_COTE_RECADRAGE_G:
							up_to_date = part;
							if (IsDlgButtonChecked(hDlg, IDC_COTE_RECADRAGE_G) == BST_CHECKED)
							{
								p.cote_recadrage |= BIT_GAUCHE;
							}
							else
							{
								p.cote_recadrage &= ~BIT_GAUCHE;
							}
							return TRUE;

						case IDC_COTE_RECADRAGE_D:
							up_to_date = part;
							if (IsDlgButtonChecked(hDlg, IDC_COTE_RECADRAGE_D) == BST_CHECKED)
							{
								p.cote_recadrage |= BIT_DROITE;
							}
							else
							{
								p.cote_recadrage &= ~BIT_DROITE;
							}
							return TRUE;

						case IDC_REPERTOIRE1_BUTTON:
							GetDir(p.repertoire1);
							SetEditString(hDlg, IDC_REPERTOIRE1, p.repertoire1);
							return TRUE;

						case IDC_REPERTOIRE2_BUTTON:
							GetDir(p.repertoire2);
							SetEditString(hDlg, IDC_REPERTOIRE2, p.repertoire2);
							return TRUE;

						case IDC_COULEUR_AUTO:
							up_to_date = part;
							i = (IsDlgButtonChecked(hDlg, IDC_COULEUR_AUTO) == BST_CHECKED ? FALSE : TRUE);
							p.isAutoColor = (i == FALSE ? TRUE : FALSE);
							EnableControl(hDlg, IDC_FOND_R, i);
							EnableControl(hDlg, IDC_FOND_V, i);
							EnableControl(hDlg, IDC_FOND_B, i);
							EnableControl(hDlg, IDC_CHOOSE_COLOR, i);
							return TRUE;

						case IDC_MAJ:
							up_to_date = part+1;
							Prg_Update(pImgPath, pImgFile, 1<<(part+1));
							Prg_LoadImage();
							Prg_DrawImage();
							return TRUE;
					}
					break;

				// on a tap quelque chose dans un edit control
				case EN_CHANGE:
					switch (LOWORD(wParam)) 
					{ 
						case IDC_REPERTOIRE1:
							GetEditString(hDlg, IDC_REPERTOIRE1, p.repertoire1);
							return TRUE;

						case IDC_REPERTOIRE2:
							GetEditString(hDlg, IDC_REPERTOIRE2, p.repertoire2);
							return TRUE;

						case IDC_DETECT_WIDTH:
							up_to_date = part;
							p.detect_width = GetEditNum(hDlg, IDC_DETECT_WIDTH);
							return TRUE;

						case IDC_DETECT_DIFF:
							up_to_date = part;
							p.detect_diff = GetEditNum(hDlg, IDC_DETECT_DIFF);
							return TRUE;

						case IDC_BLUR_RADIUS:
							up_to_date = part;
							p.blur_radius = GetEditNum(hDlg, IDC_BLUR_RADIUS);
							return TRUE;

						case IDC_BLUR_LIMIT:
							up_to_date = part;
							p.blur_limit = GetEditNum(hDlg, IDC_BLUR_LIMIT);
							return TRUE;

						case IDC_VISION_LIMIT1:
							up_to_date = part;
							p.vision_limit1 = GetEditNum(hDlg, IDC_VISION_LIMIT1);
							return TRUE;

						case IDC_VISION_LIMIT2:
							up_to_date = part;
							p.vision_limit2 = GetEditNum(hDlg, IDC_VISION_LIMIT2);
							return TRUE;

						case IDC_VISION_WIDTH1:
							up_to_date = part;
							p.vision_width1 = GetEditNum(hDlg, IDC_VISION_WIDTH1);
							return TRUE;

						case IDC_VISION_WIDTH2:
							up_to_date = part;
							p.vision_width2 = GetEditNum(hDlg, IDC_VISION_WIDTH2);
							return TRUE;

						case IDC_VISION_WIDTH3:
							up_to_date = part;
							p.vision_width3 = GetEditNum(hDlg, IDC_VISION_WIDTH3);
							return TRUE;

						case IDC_FOND_R:
							up_to_date = part;
							p.coul_remplissage.r = (u8)GetEditNum(hDlg, IDC_FOND_R);
							return TRUE;

						case IDC_FOND_V:
							up_to_date = part;
							p.coul_remplissage.g = (u8)GetEditNum(hDlg, IDC_FOND_V);
							return TRUE;

						case IDC_FOND_B:
							up_to_date = part;
							p.coul_remplissage.b = (u8)GetEditNum(hDlg, IDC_FOND_B);
							return TRUE;

						case IDC_VISION_ANGLE:
							up_to_date = part;
							p.vision_angle = GetEditFloat(hDlg, IDC_VISION_ANGLE);
							return TRUE;

						case IDC_OFFSET_ANGLE:
							up_to_date = part;
							p.offset_angle = GetEditFloat(hDlg, IDC_OFFSET_ANGLE);
							return TRUE;
					}
					break;
			}
			break;
	}
	return FALSE;
}


/////////////////////////////////////////////////////////////////////////////////////////////////////
///
/// Point d'entre du programme
///
/////////////////////////////////////////////////////////////////////////////////////////////////////
int APIENTRY _tWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
	int	style = WS_POPUP | WS_CLIPSIBLINGS | WS_CLIPCHILDREN | WS_BORDER|WS_CAPTION|WS_SYSMENU|WS_MINIMIZEBOX|WS_MAXIMIZE|WS_HSCROLL|WS_VSCROLL;
	RECT	wrk;
	s32		i;

	// rcupre le path courant
	getcwd(pCurPath, MAX_PATH);
	if (pCurPath[strlen(pCurPath)-1] != '/' && pCurPath[strlen(pCurPath)-1] != '\\')
	{
		strcat(pCurPath, "\\");
	}

	// cre le rpertoire de travail
	strcpy(pWorkDir, pCurPath);
	strcat(pWorkDir, "retouche_gui_work\\");

	if (chdir(pWorkDir) == -1)
	{
		mkdir(pWorkDir);
	}

	// rcupre la taille de l'cran sans la barre de tches
	SystemParametersInfo(SPI_GETWORKAREA, NULL, &wrk, NULL);

	// Init de la window
	g_Instance = hInstance;
	WIN_OpenWindowRect(hInstance, &wrk, NULL, (HBRUSH)COLOR_BACKGROUND, IDR_MENU1, NULL, Wnd_ManageMenu, style, Wnd_ManageScroll);
	SetWindowText(g_Win.window, PROGNAME);

	// calcule la hauteur de l'intrieur de la fentre et initialise la bitmap
	wrk.bottom -= GetSystemMetrics(SM_CYCAPTION) + GetSystemMetrics(SM_CYMENU) + GetSystemMetrics(SM_CYVSCROLL) + GetSystemMetrics(SM_CYFIXEDFRAME)*2+1;
	BITMAP_Init(&g_Win.bitmap, (u16)wrk.right, (u16)wrk.bottom, BITMAP_BGR);
	DBUF_Init(g_Win.window, &g_Win.dbuf, &g_Win.bitmap);
	BITMAP_Cls(&g_Win.bitmap, COUL_FOND);

	// calcule la largeur de la fentre
	wrk.left += 201;
	wrk.right -= GetSystemMetrics(SM_CXHSCROLL) + GetSystemMetrics(SM_CYFIXEDFRAME)*2;

	if ((wrk.right-wrk.left) & 1)
	{
		wrk.left -= 1;
	}

	// calcule les coordonnes des 2 images
	img_dstx1 = wrk.left;
	img_dstw = (wrk.right-wrk.left) / 2 - 1;
	img_dstx2 = img_dstx1 + img_dstw + 2;
	img_dsth = wrk.bottom;

	// affiche les barres verticales
	for (i=0; i<wrk.bottom; i++)
	{
		BITMAP_SetPix(&g_Win.bitmap, img_dstx1-1, i, RGB(0, 0, 0));
		BITMAP_SetPix(&g_Win.bitmap, img_dstx1-2, i, RGB(255, 255, 255));
		BITMAP_SetPix(&g_Win.bitmap, img_dstx2-1, i, RGB(0, 0, 0));
		BITMAP_SetPix(&g_Win.bitmap, img_dstx2-2, i, RGB(255, 255, 255));
	}

	// copie la bitmap dans la fentre
	BitBlt(g_Win.dbuf.windowcontext, 0, 0, g_Win.bitmap.width, g_Win.bitmap.height, g_Win.dbuf.backbufcontext, 0, 0, SRCCOPY);

	// Init du menu
	g_Menu = GetMenu(g_Win.window);

	// init des paramtres par dfaut
	Prg_DefaultParams();

	// This shows our window.
	ShowWindow (g_Win.window, nCmdShow);
	UpdateWindow(g_Win.window);
	Prg_SetScroll();

	// initialise les dialogues
	CreateDialog(hInstance,MAKEINTRESOURCE(IDD_DIALOG1),g_Win.window, (DLGPROC)DialogMessages);
	g_CurDial = CreateDialog(hInstance,MAKEINTRESOURCE(IDD_DIALOG2),g_Win.window, (DLGPROC)DialogMessages);
	CreateDialog(hInstance,MAKEINTRESOURCE(IDD_DIALOG_MAJ),g_Win.window, (DLGPROC)DialogMessages);

	// boucle principale
	while (1)
	{
		if (WIN_WaitForFrame(FALSE) == TRUE)
		{
			break;
		}
	}

	UnregisterClass("Window Class",hInstance);
	return (0);
}
