#ifndef	WINSTUF_H
#define	WINSTUF_H

#include	<windows.h>
#include "bitmap.h"

typedef void (*TMenuCallback)(HWND p_window, u32 p_menu);
typedef LRESULT (*TMsgCB)(HWND hwnd, UINT iMsg, WPARAM wParam, LPARAM lParam);

enum
{
	FR_LOAD,
	FR_SAVE,
	FR_MULTI,
	FR_DIR
};

enum
{
	KEY_NONE,
	KEY_TRIG,
	KEY_CONT,
	KEY_RELEASE,
	KEY_REPEAT
};

typedef struct SDBufInfo
{
	HDC	windowcontext, backbufcontext;
	HBITMAP	oldbitmap, backbufbitmap;
} TDBufInfo;

typedef struct SWIN
{
	u8				key[0x100];
	HWND			window;
	TDBufInfo		dbuf;
	TBitmap			bitmap;
	TMenuCallback	menucallback;
	TMsgCB			msgcallback;
	u32				frame;
	u8				timer:1;
} TWIN;

void DBUF_CopyBuffer(TDBufInfo *p_dbi, TBitmap *p_bitmap);
void DBUF_Init(HWND p_window, TDBufInfo *p_dbi, TBitmap *p_bitmap);
void DBUF_Free(HWND p_window, TDBufInfo *p_dbi, TBitmap *p_bitmap);


HWND	WIN_OpenWindowRect(HINSTANCE p_hInstance, RECT *p_pRect, char *p_pCursor, HBRUSH p_background, u32 p_menu, u32 p_icon, TMenuCallback p_mcb, int p_style, TMsgCB p_mscb);
HWND	WIN_OpenWindow(HINSTANCE p_hInstance, u16 p_width, u16 p_height, char *p_pCursor, HBRUSH p_background, u32 p_menu, u32 p_icon, TMenuCallback p_mcb);
void	WIN_FileRequest(HWND p_window, char *p_pResult, u32 p_type, char *p_pTitle, char *p_pFilter, char *p_pInitdir, char *p_pInitfile);
void	WIN_Print(u32 p_x, u32 p_y, const char *p_pFormat, ...);
u32		WIN_WaitForFrame(u32 p_isRedraw);
LRESULT CALLBACK WIN_StdMessages(HWND hwnd, UINT iMsg, WPARAM wParam, LPARAM lParam);
void	WIN_StdClose(HWND p_hwnd);
void	WIN_Redraw(void);

extern TWIN	g_Win;

#endif
