// retouche.cpp : Defines the entry point for the console application.
//

//  faire: messages d'erreur pour les fichiers
// numro de version

#include "stdafx.h"
#include <windows.h>
#include <math.h>
#include <stdlib.h>

struct SParams
{
	int		detect_width;
	int		detect_diff;
	int		blur_radius;
	int		blur_limit;
	int		vision_limit1;
	int		vision_limit2;
	int		vision_width1;
	int		vision_width2;
	int		vision_width3;
	double	vision_angle;
	char	repertoire1[256];
	char	repertoire2[256];
};

struct SParams	p;

// lecture des paramtres
void GetParams(void)
{
	FILE	*pFile;
	char	pTmp[256];
	char	pTmp2[256];
	char	*pPtr;

	p.detect_width = 20;
	p.detect_diff = 25;
	p.vision_limit1 = 64;
	p.vision_limit2 = 3;
	p.vision_width1 = 16;
	p.vision_width2 = 16;
	p.vision_width3 = 128;
	p.vision_angle = 3.0;
	p.blur_radius = 3;
	p.blur_limit = 50;
	strcpy(p.repertoire1, "c:/t/");
	strcpy(p.repertoire2, "c:/trot/");

	pFile = fopen("config.txt", "r");

	if (pFile == NULL)
	{
		return;
	}

	while (fgets(pTmp, 256, pFile) != NULL)
	{
		while(pTmp[strlen(pTmp)-1] == 0xA || pTmp[strlen(pTmp)-1] ==0xD)
		{
			pTmp[strlen(pTmp)-1] = 0;
		}

		pPtr = strchr(pTmp, '=');

		if (pPtr != NULL)
		{
			memcpy(pTmp2, pTmp, pPtr-pTmp);
			pTmp2[pPtr-pTmp] = 0;
			strupr(pTmp2);

			if (strcmp(pTmp2, "DETECT_WIDTH") == 0)
			{
				sscanf(pPtr+1, "%d", &p.detect_width);
			}
			else if (strcmp(pTmp2, "DETECT_DIFF") == 0)
			{
				sscanf(pPtr+1, "%d", &p.detect_diff);
			}
			else if (strcmp(pTmp2, "VISION_LIMIT1") == 0)
			{
				sscanf(pPtr+1, "%d", &p.vision_limit1);
			}
			else if (strcmp(pTmp2, "VISION_LIMIT2") == 0)
			{
				sscanf(pPtr+1, "%d", &p.vision_limit2);
			}
			else if (strcmp(pTmp2, "VISION_WIDTH1") == 0)
			{
				sscanf(pPtr+1, "%d", &p.vision_width1);
			}
			else if (strcmp(pTmp2, "VISION_WIDTH2") == 0)
			{
				sscanf(pPtr+1, "%d", &p.vision_width2);
			}
			else if (strcmp(pTmp2, "VISION_WIDTH3") == 0)
			{
				sscanf(pPtr+1, "%d", &p.vision_width3);
			}
			else if (strcmp(pTmp2, "VISION_ANGLE") == 0)
			{
				float tmp = 0.0;

				sscanf(pPtr+1, "%f", &tmp);
				p.vision_angle = tmp;
			}
			else if (strcmp(pTmp2, "BLUR_RADIUS") == 0)
			{
				sscanf(pPtr+1, "%d", &p.blur_radius);
			}
			else if (strcmp(pTmp2, "BLUR_LIMIT") == 0)
			{
				sscanf(pPtr+1, "%d", &p.blur_limit);
			}
			else if (strcmp(pTmp2, "REPERTOIRE1") == 0)
			{
				pPtr++;

				if (*pPtr == '\"')
				{
					pPtr++;
				}

				strcpy(pTmp2, pPtr);

				while (pTmp2[strlen(pTmp2)-1] == ' ')
				{
					pTmp2[strlen(pTmp2)-1] = 0;
				}

				if (pTmp2[strlen(pTmp2)-1] == '\"')
				{
					pTmp2[strlen(pTmp2)-1] = 0;
				}
				strcpy(p.repertoire1, pTmp2);
			}
			else if (strcmp(pTmp2, "REPERTOIRE2") == 0)
			{
				pPtr++;

				if (*pPtr == '\"')
				{
					pPtr++;
				}

				strcpy(pTmp2, pPtr);

				while (pTmp2[strlen(pTmp2)-1] == ' ')
				{
					pTmp2[strlen(pTmp2)-1] = 0;
				}

				if (pTmp2[strlen(pTmp2)-1] == '\"')
				{
					pTmp2[strlen(pTmp2)-1] = 0;
				}
				strcpy(p.repertoire2, pTmp2);
			}
			else
			{
				printf("paramtre inconnu \"%s\"\n", pTmp2);
			}
		}
	}
	fclose(pFile);
}

void GetRGB(int p_c, int *p_pR, int *p_pG, int *p_pB)
{
	*p_pR = p_c & 0xFF;
	*p_pG = (p_c >> 8) & 0xFF;
	*p_pB = (p_c >> 16) & 0xFF;
}

int GetNumBits(BITMAPINFOHEADER *p_pInfo)
{
	int bits = p_pInfo->biPlanes * p_pInfo->biBitCount;

	if (bits == 1) 
        return(1);
    else if (bits <= 4) 
        return(4);
    else if (bits <= 8) 
        return(8);
    else if (bits <= 16) 
        return(16);
    else if (bits <= 24) 
        return(24);
    else return(32);
}

int GetPx(int p_realwidth, int p_height, unsigned char *p_pImg, int p_x, int p_y, int p_numbits)
{
	unsigned char *pAddr;
	int	i, c = 0;
	int	bytes = p_numbits / 8;

	pAddr = p_pImg + (p_height-1 - p_y) * p_realwidth + p_x * bytes;

	for (i=0; i<bytes; i++)
	{
		c += (pAddr[i] << (i*8));
	}

	if (bytes == 1)
	{
		c = (c << 16) + (c << 8) + c;
	}
	return (c);
}

void SetPx(int p_realwidth, int p_height, unsigned char *p_pImg, int p_x, int p_y, int p_numbits, int p_coul)
{
	unsigned char *pAddr;
	int	i;
	int	bytes = p_numbits / 8;

	pAddr = p_pImg + (p_height-1 - p_y) * p_realwidth + p_x * bytes;

	for (i=0; i<bytes; i++)
	{
		pAddr[i] = (unsigned char)(p_coul >> (i*8));
	}
}

int RecadreDroite(BITMAPINFOHEADER *p_pInfo, unsigned char *p_pBM, int p_numbits, int p_br, int p_bg, int p_bb, int p_realwidth)
{
	int	i, j, k, c, dif, r, g, b;

	for (j=p_pInfo->biWidth-1; j>=0; j--)
	{
		for (i=0; i<p_pInfo->biHeight-p.detect_width; i++)
		{
			for (k=0; k<p.detect_width; k++)
			{
				c = GetPx(p_realwidth, p_pInfo->biHeight, p_pBM, j, i+k, p_numbits);
				GetRGB(c, &r, &g, &b);
				dif = abs(r - p_br) + abs(g - p_bg) + abs(b - p_bb);

				if (dif < p.detect_diff*3)
				{
					break;
				}
			}

			if (k == p.detect_width)
			{
				break;
			}
		}

		if (i != p_pInfo->biHeight-p.detect_width)
		{
			break;
		}
	}
	return (j+1);
}

int RecadreBas(BITMAPINFOHEADER *p_pInfo, unsigned char *p_pBM, int p_numbits, int p_br, int p_bg, int p_bb, int p_realwidth)
{
	int	i, j, k, c, dif, r, g, b;

	for (j=p_pInfo->biHeight-1; j>=0; j--)
	{
		for (i=0; i<p_pInfo->biWidth-p.detect_width; i++)
		{
			for (k=0; k<p.detect_width; k++)
			{
				c = GetPx(p_realwidth, p_pInfo->biHeight, p_pBM, i+k, j, p_numbits);
				GetRGB(c, &r, &g, &b);
				dif = abs(r - p_br) + abs(g - p_bg) + abs(b - p_bb);

				if (dif < p.detect_diff*3)
				{
					break;
				}
			}

			if (k == p.detect_width)
			{
				break;
			}
		}

		if (i != p_pInfo->biWidth-p.detect_width)
		{
			break;
		}
	}
	return (j+1);
}

void SaveBMP(char *p_pName, BITMAPFILEHEADER *p_pHead, BITMAPINFOHEADER *p_pInfo, RGBQUAD *p_pPal, unsigned char *p_pImg)
{
	FILE	*pFile;
	int		numbits = GetNumBits(p_pInfo);

	pFile = fopen(p_pName, "wb");

	if (pFile == NULL)
	{
		printf("Erreur: impossible d'ouvrir le fichier \"%s\"\n", p_pName);
		return;
	}

	fwrite(p_pHead, 1, sizeof(BITMAPFILEHEADER), pFile);
	fwrite(p_pInfo, 1, sizeof(BITMAPINFOHEADER), pFile);

	if (numbits != 24 && p_pPal != NULL)
	{
		fwrite(p_pPal, 1, p_pInfo->biClrUsed * sizeof(RGBQUAD), pFile);
	}
	fwrite(p_pImg, 1, p_pInfo->biSizeImage, pFile);
	fclose(pFile);
}

void GetBGCol(BITMAPINFOHEADER *p_pInfo, unsigned char *p_pImg, int *p_pR, int *p_pG, int *p_pB, int p_realwidth)
{
	int	numbits = GetNumBits(p_pInfo);
	int	tr, tg, tb, i, c;

	*p_pR = 0;
	*p_pG = 0;
	*p_pB = 0;

	for (i=0; i<p_pInfo->biHeight; i++)
	{
		c = GetPx(p_realwidth, p_pInfo->biHeight, p_pImg, p_pInfo->biWidth-1, i, numbits);
		GetRGB(c, &tr, &tg, &tb);
		*p_pR += tr;
		*p_pG += tg;
		*p_pB += tb;
	}
	*p_pR /= p_pInfo->biHeight;
	*p_pG /= p_pInfo->biHeight;
	*p_pB /= p_pInfo->biHeight;
}

int _tmain(int argc, _TCHAR* argv[])
{
	FILE				*pFile;
	BITMAPFILEHEADER	fhead;
	BITMAPINFOHEADER	info;
	RGBQUAD				*pPalette = NULL;
	unsigned char		*pImg = NULL;
	unsigned char		*pNewImg = NULL;
	unsigned char		*pWork = NULL;
	unsigned char		*pPtr = NULL;
	int					numbits, i, j, ii, jj, k, xx, yy, c, r, g, b, br, bg, bb, r2, g2, b2, tr, tg, tb, dx, dy, dz, mr, mg, mb, newheight, newwidth, realwidth, newrealwidth;
	int					*pBlur;
	int					*pBlur2;
	char				pDest[256];
	double				angle, angle2, sigma;
	double				pi = 3.14159265359;
	double				center_x, center_y, x, y, savex, savey;
	double				incx, incy, dist, disx, disy, disx2, disy2, fr, fg, fb, fac;

	/***************************************************************************************************
	 *
	 * Chargement
	 *
	 ***************************************************************************************************/

	if (argc != 2)
	{
		printf("retouche v1.0\n");
		printf("  usage: retouche <nom de fichier>\n");
		return (0);
	}

	GetParams();

	// charge un BMP
	pFile = fopen(argv[1], "rb");

	if (pFile == NULL)
	{
		printf("Erreur: impossible d'ouvrir le fichier \"%s\"\n", argv[1]);
		return(0);
	}

	fread(&fhead, 1, sizeof(BITMAPFILEHEADER), pFile);
	fread(&info, 1, sizeof(BITMAPINFOHEADER), pFile);
	numbits = GetNumBits(&info);

	if (numbits != 24)
	{
		pPalette = (RGBQUAD *)malloc(info.biClrUsed * sizeof(RGBQUAD));
		fread(pPalette, 1, info.biClrUsed * sizeof(RGBQUAD), pFile);
	}
	pImg = (unsigned char *)malloc(info.biSizeImage);
	fread(pImg, 1, info.biSizeImage, pFile);
	fclose(pFile);

	realwidth = ((info.biWidth * numbits +31) & ~31) /8;


	/***************************************************************************************************
	 *
	 * Recadrage
	 *
	 ***************************************************************************************************/

	// get background color
	GetBGCol(&info, pImg, &br, &bg, &bb, realwidth);

	// coupe  droite
	newwidth = RecadreDroite(&info, pImg, numbits, br, bg, bb, realwidth);

	// coupe en bas
	newheight = RecadreBas(&info, pImg, numbits, br, bg, bb, realwidth);

	newrealwidth = ((newwidth * numbits +31) & ~31) /8;


	/***************************************************************************************************
	 *
	 * Flou
	 *
	 ***************************************************************************************************/

	// init du flou
	pBlur = (int *)malloc(sizeof(int)*(2*p.blur_radius+1)*(2*p.blur_radius+1));
	pBlur2 = pBlur;
	sigma = (double)p.blur_radius / 3.0;

	for (j=-p.blur_radius; j<p.blur_radius+1; j++)
	{
		double e;

		for (i=-p.blur_radius; i<p.blur_radius+1; i++)
		{
			e = (double)(i*i+j*j);
			e = exp(-e / (2.0*sigma*sigma));
			*pBlur2++ = (int)(e * 1024.0);
		}
	}


	// rcrit l'image avec un flou
	info.biSizeImage = newrealwidth * newheight;
	pNewImg = (unsigned char *)malloc(info.biSizeImage);

	for (j=0; j<newheight; j++)
	{
		for (i=0; i<newwidth; i++)
		{
			c = GetPx(realwidth, info.biHeight, pImg, i, j, numbits);
			GetRGB(c, &mr, &mg, &mb);
			r = 0;
			g = 0;
			b = 0;
			k = 0;
			pBlur2 = pBlur;

			for (yy=-p.blur_radius; yy<p.blur_radius+1; yy++)
			{
				for (xx=-p.blur_radius; xx<p.blur_radius+1; xx++)
				{
					if (i+xx >= 0 && i+xx < newwidth && j+yy >= 0 && j+yy < newheight)
					{
						c = GetPx(realwidth, info.biHeight, pImg, i+xx, j+yy, numbits);
						GetRGB(c, &r2, &g2, &b2);
						dx = mr - r2;
						dy = mg - g2;
						dz = mb - b2;

						if (dx*dx + dy*dy + dz*dz < p.blur_limit*p.blur_limit)
						{
							r += *pBlur2 * r2;
							g += *pBlur2 * g2;
							b += *pBlur2 * b2;
							k += *pBlur2;
						}
					}
					pBlur2++;
				}
			}
			r /= k;
			g /= k;
			b /= k;
			c = (b << 16) + (g << 8) + r;
			SetPx(newrealwidth, newheight, pNewImg, i, j, numbits, c);
		}
	}
	free(pBlur);

	info.biWidth = newwidth;
	info.biHeight = newheight;
	fhead.bfSize = sizeof(BITMAPFILEHEADER) + info.biSize + info.biClrUsed * sizeof(RGBQUAD) + info.biSizeImage; 
	free(pImg);


	/***************************************************************************************************
	 *
	 * Dtection de l'angle de rotation
	 *
	 ***************************************************************************************************/

	pWork = (unsigned char *)malloc(newwidth * newheight);
	// cre le buffer de travail
	pPtr = pWork;
	for (j=0; j<newheight; j++)
	{
		for (i=0; i<newwidth; i++)
		{
			c = GetPx(newrealwidth, newheight, pNewImg, i, j, numbits);
			GetRGB(c, &tr, &tg, &tb);
			*pPtr++ = (tr+tg+tb) / 3;
		}
	}

	// ne garde que les transitions verticales franches
	pPtr = pWork;
	for (j=0; j<newheight; j++)
	{
		for (i=0; i<newwidth; i++)
		{
			if (j == newheight-1)
			{
				*pPtr++ = 0;
			}
			else
			{
				c = abs(pPtr[0] - pPtr[newwidth]);
				*pPtr++ = (c < p.vision_limit1 ? 0 : 255);
			}
		}
	}

	// ne garde que les transition frquentes
	pPtr = pWork;
	for (j=0; j<newheight; j++)
	{
		for (i=0; i<newwidth; i++)
		{
			c = 0;

			if (i < newwidth-p.vision_width1)
			{
				for (xx=0; xx<p.vision_width1-p.vision_limit2; xx++)
				{
					for (yy=0; yy<p.vision_limit2; yy++)
					{
						if (pPtr[xx+yy] == 0)
						{
							break;
						}
					}

					if (yy == p.vision_limit2)
					{
						c++;
					}
				}
			}
			*pPtr++ = (c != 0 ? 255 : 0);
		}
	}

	// tend les lignes
	for (j=0; j<newheight; j++)
	{
		for (i=0; i<newwidth; i++)
		{
			pPtr = &pWork[j*newwidth+i];

			if (pPtr[0] == 0 && i != 0)
			{
				if (pPtr[-1] == 255)
				{
					for (xx=0; xx<p.vision_width2; xx++)
					{
						if (i+xx >= newwidth)
						{
							i = newwidth;
							break;
						}

						if (pPtr[xx] == 255 || (j != 0 && pPtr[xx-newwidth] == 255) || (j != newheight-1 && pPtr[xx+newwidth] == 255))
						{
							for (yy=0; yy<xx; yy++)
							{
								*pPtr++ = 1;
								i++;
							}
							pPtr++;
							i++;
							break;
						}
					}
				}
			}
		}
	}

	// lignes d'1 pixel
	pPtr = pWork;
	for (j=0; j<newheight; j++)
	{
		for (i=0; i<newwidth; i++)
		{
			c = 0;

			if (j < newheight-1)
			{
				if (pPtr[0] != 0 && pPtr[newwidth] == 0)
				{
					c = 255;
				}
			}
			*pPtr++ = c;
		}
	}

	// limine les parasites
	angle = 0.0;
	fac = 0;
	for (i=0; i<newwidth; i++)
	{
		for (j=0; j<newheight; j++)
		{
			if (pWork[j*newwidth+i] == 255)
			{
				xx = i;
				yy = j;

				while (1)
				{
					pWork[yy*newwidth+xx] = 0;

					if (xx >= newwidth-1)
					{
						break;
					}

					if (pWork[yy*newwidth+xx+1] != 0)
					{
						xx++;
					}
					else if (yy > 0 && pWork[(yy-1)*newwidth+xx+1] != 0)
					{
						xx++;
						yy--;
					}
					else if (yy < newheight-1 && pWork[(yy+1)*newwidth+xx+1] != 0)
					{
						xx++;
						yy++;
					}
					else
					{
						break;
					}
				}

				if (xx - i >= p.vision_width3)
				{
					angle2 = atan2((double)(j-yy), (double)(xx-i));
					angle2 = angle2 * 180.0 / pi;

					if (fabs(angle2) < p.vision_angle)
					{
						dist = (double)(xx-i);
						angle += dist * angle2;
						fac += dist;
					}
				}
			}
		}
	}
	free(pWork);

	if (fac != 0.0)
	{
		angle = angle / fac;
	}


	/***************************************************************************************************
	 *
	 * Sauvegarde
	 *
	 ***************************************************************************************************/

	// sauve un BMP
	strcpy(pDest, p.repertoire1);
	strcat(pDest, argv[1]);
	SaveBMP(pDest, &fhead, &info, pPalette, pNewImg);

	/***************************************************************************************************
	 *
	 * Rotation
	 *
	 ***************************************************************************************************/

	pWork = (unsigned char *)malloc(info.biSizeImage);

	for (j=0; j<newheight; j++)
	{
		for (i=0; i<newwidth; i++)
		{
			SetPx(newrealwidth, newheight, pWork, i, j, numbits, (bb << 16)+(bg <<8)+br);
		}
	}
	printf("%f\n", angle);
	center_x = (float)newwidth / 2.0 - 0.5;
	center_y = (float)newheight / 2.0 - 0.5;
	dist = sqrt(center_x*center_x + center_y*center_y);
	angle = angle * pi / 180.0;
	angle2 = atan2(-center_y, center_x);
	x = center_x+0.5 - dist * cos(angle2+angle);
	y = center_y+0.5 + dist * sin(angle2+angle);
	savex = x;
	savey = y;
	incx = cos(angle);
	incy = -sin(angle);

	for (j=0; j<newheight; j++)
	{
		x = savex;
		y = savey;
		savex -= incy;
		savey += incx;

		for (i=0; i<newwidth; i++)
		{
			xx = (int)floor(x);
			yy = (int)floor(y);
			fac = 0.0;
			fr = 0.0;
			fg = 0.0;
			fb = 0.0;

			for (ii=-1; ii<3; ii++)
			{
				for (jj=-1; jj<3; jj++)
				{
					disx = fabs((double)xx + (double)ii + 0.5 - x);
					disy = fabs((double)yy + (double)jj + 0.5 - y);
					disx2 = disx*disx;
					disy2 = disy*disy;

					if (disx < 1.0)
					{
						dist = 1.5 * disx2*disx - 2.5 * disx*disx + 1.0;
					}
					else if (disx < 2.0)
					{
						dist = -0.5 * disx2*disx + 2.5 * disx2 - 4.0 * disx + 2.0;
					}
					else
					{
						dist = 0.0;
					}

					if (disy < 1.0)
					{
						dist *= 1.5 * disy2*disy - 2.5 * disy*disy + 1.0;
					}
					else if (disy < 2.0)
					{
						dist *= -0.5 * disy2*disy + 2.5 * disy2 - 4.0 * disy + 2.0;
					}
					else
					{
						dist = 0.0;
					}

					if (xx+ii >= 0 && xx+ii < newwidth && yy+jj >= 0 && yy+jj < newheight)
					{
						c = GetPx(newrealwidth, newheight, pNewImg, xx+ii, yy+jj, numbits);
						GetRGB(c, &r, &g, &b);
					}
					else
					{
						r = br;
						g = bg;
						b = bb;
					}

					fac += dist;
					fr += dist * (double)r;
					fg += dist * (double)g;
					fb += dist * (double)b;
				}
			}

			fr /= fac;
			fg /= fac;
			fb /= fac;
			r = (int)floor(fr);
			g = (int)floor(fg);
			b = (int)floor(fb);

			if (r < 0) r = 0;
			if (r > 255) r = 255;
			if (g < 0) g = 0;
			if (g > 255) g = 255;
			if (b < 0) b = 0;
			if (b > 255) b = 255;

			c = (b << 16) + (g << 8) + r;
			SetPx(newrealwidth, newheight, pWork, i, j, numbits, c);

			x += incx;
			y += incy;
		}
	}

	free(pNewImg);


	/***************************************************************************************************
	 *
	 * Recadrage 2
	 *
	 ***************************************************************************************************/

	realwidth = newrealwidth;

	// coupe  droite
	newwidth = RecadreDroite(&info, pWork, numbits, br, bg, bb, realwidth);

	// coupe en bas
	newheight = RecadreBas(&info, pWork, numbits, br, bg, bb, realwidth);

	newrealwidth = ((newwidth * numbits +31) & ~31) /8;


	/***************************************************************************************************
	 *
	 * Rcriture
	 *
	 ***************************************************************************************************/

	// recopie l'image
	info.biSizeImage = newrealwidth * newheight;
	pNewImg = (unsigned char *)malloc(info.biSizeImage);

	for (j=0; j<newheight; j++)
	{
		for (i=0; i<newwidth; i++)
		{
			c = GetPx(realwidth, info.biHeight, pWork, i, j, numbits);
			SetPx(newrealwidth, newheight, pNewImg, i, j, numbits, c);
		}
	}

	info.biWidth = newwidth;
	info.biHeight = newheight;
	fhead.bfSize = sizeof(BITMAPFILEHEADER) + info.biSize + info.biClrUsed * sizeof(RGBQUAD) + info.biSizeImage; 
	free(pWork);

	/***************************************************************************************************
	 *
	 * Sauvegarde 2
	 *
	 ***************************************************************************************************/

	// sauve un BMP
	strcpy(pDest, p.repertoire2);
	strcat(pDest, argv[1]);
	SaveBMP(pDest, &fhead, &info, pPalette, pNewImg);

	/***************************************************************************************************
	 *
	 * Fin
	 *
	 ***************************************************************************************************/
	free(pNewImg);

	if (pPalette != NULL)
	{
		free(pPalette);
	}

	printf("%s done.\n", argv[1]);
	return 0;
}
