#ifndef	BITMAP_H
#define	BITMAP_H

#include "MyTypes.h"

enum
{
	BITMAP_256,
	BITMAP_GREY,
	BITMAP_RGB,
	BITMAP_BGR,
};

typedef struct
{
	u16	width, height;
	u8	format;
	u8	*pPalette;
	u8	*pMem;
} TBitmap;

#define	BITMAP_ADDR8(_bm,_x,_y) ((_bm)->pMem + (_y) * (_bm)->width + (_x))
#define	BITMAP_ADDR16(_bm,_x,_y) ((_bm)->pMem + ((_y) * (_bm)->width + (_x)) * 2)
#define	BITMAP_ADDR24(_bm,_x,_y) ((_bm)->pMem + ((_y) * (_bm)->width + (_x)) * 3)

void	BITMAP_Init(TBitmap *p_pBitmap, u16 p_width, u16 p_height, u8 p_format);
u32		BITMAP_Alloc(TBitmap *p_pBitmap, u16 p_width, u16 p_height, u8 p_format);
void	BITMAP_Free(TBitmap *p_pBitmap);
void	BITMAP_Blt(TBitmap *p_pSrcbitmap, TBitmap *p_pDstbitmap, s32 posx, s32 posy);
u32		BITMAP_Clr(TBitmap *p_pBitmap, u8 p_r, u8 p_g, u8 p_b);

#endif
