#ifndef	TGA_H
#define	TGA_H

#include "MyTypes.h"
#include "bitmap.h"

#define TGA_FORMAT_HASPALETTE	0x01
#define TGA_FORMAT_COMPRESSION	0x0800
enum
{
	TGA_FORMAT_UNKNOWN,
	TGA_FORMAT_INDEXED,
	TGA_FORMAT_RGB,
	TGA_FORMAT_GREY,
};

#define	TGA_FLAG_TOP2BOTTOM	(1 << 5)

#define	TGA_HEADER_SIZE 18

typedef struct
{
	u8	alpha;			/// 0
	u8	format:2,		/// 1, 2
		compression:1,	/// 1, 2
		haspalette:1;	/// 1, 2
	u16	lut;			/// 3, 4
	u16	palsize;		/// 5, 6
	u8	palbits;		/// 7
	u32 unknown;		/// 8, 9, 10, 11
	u16	width;			/// 12, 13
	u16	height;			/// 14, 15
	u8	imgbits;		/// 16
	u8	flags;			/// 17
} TTGA_Header;

void	TGA_EncodeHeader(TTGA_Header *pHeader, u8 *pHeadBuf);
void	TGA_DecodeHeader(TTGA_Header *pHeader, u8 *pHeadBuf);
u32		TGA_Save(char *p_pFilename, TBitmap *p_pBitmap);
u32		TGA_Load(char *p_pFilename, TBitmap *p_pBitmap);

#endif
