////////////////////////////////////////////////////////////////
///
/// Memory routines
///
/////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include <stdio.h>
#include <stdlib.h>
#include "MyTypes.h"
#include "error.h"

////////////////////////////////////////////////////
///
/// Alloue de la mmoire et affiche un message d'erreur si il y a un problme
///
////////////////////////////////////////////////////
void *MEM_Alloc(u32 p_size)
{
	u8		*pMem;

	if ((pMem = (u8 *)malloc(p_size)) == NULL)
	{
		Error("Not enough memory\n");
	}

	return (pMem);
}

////////////////////////////////////////////////////
///
/// Alloue de la mmoire et la vide. Affiche un message d'erreur si il y a un problme
///
////////////////////////////////////////////////////
void *MEM_Calloc(u32 p_size)
{
	u8		*pMem;

	if ((pMem = (u8 *)calloc(p_size, 1)) == NULL)
	{
		Error("Not enough memory\n");
	}

	return (pMem);
}

////////////////////////////////////////////////////
///
/// Libre la mmoire et met le pointeur  NULL
///
////////////////////////////////////////////////////
void MEM_Free(void **p_pMem)
{
	if (*p_pMem != NULL)
	{
		free(*p_pMem);
		*p_pMem = NULL;
	}
}
